"""
Processor to process logs and give predicted, actual in csv table form
Due to legacy issues, this script works only for the case when the predicted and actual
are present as a string and not as a list.
So clearly, it will work only for one prediction cases
:author: gurnoorsingh (20221121)
"""
import argparse

RELAY_REGIONS = {
    'r19.algorand-testnet.network:4161': "China",
    'relay-virginia-testnet-algorand.algorand-testnet.network:4161': "USA",
    'oregong-algorand-test-1.algorand-testnet.network:4161': "USA",
    'singaporeg-algorand-test-1.algorand-testnet.network:4161': "Singapore",
    'londong-algorand-test-2.algorand-testnet.network:4161': "London",
    'singaporeg-algorand-test-2.algorand-testnet.network:4161': "Singapore",
    'relay-switzerland1-testnet-algorand.algorand-testnet.network:80': "Switzerland",
    'londong-algorand-test-1.algorand-testnet.network:4161': "London"
}


parser = argparse.ArgumentParser()
parser.add_argument('-f', '--filename', help="Log file name", required=True)
args = parser.parse_args()

exact_match_count = 0
region_match_count = 0
with open(args.filename) as fh:
    for line in fh.readlines():
        if "DEBUG - predicted:" in line:
            line_data = line.split('-', 2)
            predictions = line_data[2].split()[1]
            actual = line_data[2].split()[3]
            if predictions == actual:
                exact_match_count += 1
            if RELAY_REGIONS[predictions] == RELAY_REGIONS[actual]:
                region_match_count += 1
            print(f"{predictions},{actual}")

print(exact_match_count)
print(region_match_count)
