"""
Utility functions used throughout in various files
:author: gurnoorsingh (20221110)
"""

import os
import json
import subprocess

def get_sender_relays():
    log_file_path = "/home/azureuser/.algorand/node.log"
    command = f"grep OutgoingPeers {log_file_path} | tail -n 1"
    with subprocess.Popen(command, stdout=subprocess.PIPE, stderr=None, shell=True) as process:
        output = process.communicate()[0].decode("utf-8")
        endpoints = []
        outgoing_peers_list = json.loads(output)["details"]["OutgoingPeers"]
        for i in range(len(outgoing_peers_list)):
            endpoints.append(outgoing_peers_list[i]["Endpoint"])

    return endpoints


def filter_logs_by_txn_id(txn_id):
    """
    filters the log file to get only the logs containing txn with txn_id
    """
    log_file_path = "/home/azureuser/node/data/node.log"
    os.system(f"grep {txn_id} {log_file_path} > /home/azureuser/algorand-topology/filtered_logs/data_{txn_id}")